#!/bin/sh

#  chkcfg.sh version 0.01 
#  released 11 Nov 2002
#
#  Copyright (C) 2002 by Sapon Oleg
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.

PATHTODIR=.
DMIDECODE=dmidecode
MACADDR=`/sbin/ifconfig|grep "eth0 "| awk '{print $5}' | sed s/://g`
LOGFILE=$PATHTODIR/$MACADDR

#Bash parameters
NEWIFS=$'\n'
OLDIFS=$IFS

echo "[Info]" > $LOGFILE
echo "MAC_Addr=${MACADDR}" >> $LOGFILE
echo "System=`cat /proc/version`" >> $LOGFILE
echo "Current_User_Name=$USER" >> $LOGFILE
echo "Computer_Name=$HOSTNAME" >> $LOGFILE
echo "Param_0=chkcfg.sh version 0.01" >> $LOGFILE
echo "Record_Date=`date +%x`" >> $LOGFILE
echo "IP_Addr=`hostname -i`" >> $LOGFILE #TEMORARY
echo "[Computer]" >> $LOGFILE
BIOS=`${DMIDECODE}|grep -A3 "BIOS Information Block"`
echo "BIOS=`echo ${BIOS}|sed -e 's/BIOS Information Block Vendor: //' -e 's/Version: //' -e 's/Release: //'`" >> $LOGFILE
echo "CPU_Freq_in_MHz=`cat /proc/cpuinfo|grep MHz|sed 's/\./ /'|awk '{print $4}'`" >> $LOGFILE

if [ "`cat /proc/cpuinfo|grep processor|awk {'print $3'}`" == 1 ]; then
echo "CPU=2x `cat /proc/cpuinfo|grep "model name"|awk '{print $4 " " $5 " " $6 " " $7 " " $8}'`" >> $LOGFILE
else
echo "CPU=`cat /proc/cpuinfo|grep "model name"|awk '{print $4 " " $5 " " $6 " " $7 " " $8}'`" >> $LOGFILE
fi

echo "Memory_in_Mb=`cat /proc/meminfo|grep Mem:|awk '{print $2/1000000}'|sed 's/\./ /'|awk '{print $1}'`" >> $LOGFILE

FDISK=`cat /proc/devices|grep fd`
if [ ! "$FDISK" = "" ]; then
    echo "Drive_0=REMOVABLE" >> $LOGFILE
fi

HDDTOTAL=0
DISKNO=3
for HD in a b c d; do
    if [ -x /proc/ide/hd${HD} ]; then
        if [ `cat /proc/ide/hd${HD}/media` = "disk" ]; then
	    echo "Drive_${DISKNO}=Hard Disk" >> $LOGFILE
	    HDD="${HDD}`cat /proc/ide/hd${HD}/model`:"
	    let HDDTOTAL=HDDTOTAL+`cat /proc/ide/hd${HD}/capacity`
	else
	    echo "Drive_${DISKNO}=CD-ROM" >> $LOGFILE
	    CDROM="${CDROM}`cat /proc/ide/hd${HD}/model`:"
	fi
	let DISKNO++
    fi
done
let HDDTOTAL=HDDTOTAL/1000000*512
echo "Total_HDD_in_Mb=${HDDTOTAL}" >> $LOGFILE

DEVNO=0
IFS=$NEWIFS
echo "[Current_Config]" >> $LOGFILE

for VIDEO in `cat /proc/pci|grep "VGA compatible controller:"|sed -e 's/VGA compatible controller://' -e 's/     //'`; do
    if [ ! "$VIDEO" = "" ]; then
	echo "Device_${DEVNO}=Display ${VIDEO}" >> $LOGFILE
	let DEVNO++
    fi
done

for ENET in `cat /proc/pci|grep "Ethernet controller:"|sed -e 's/Ethernet controller://' -e 's/     //'`; do
    if [ ! "$ENET" = "" ]; then
	echo "Device_${DEVNO}=Net ${ENET}" >> $LOGFILE
	let DEVNO++
    fi
done

IFS=':'
for HDISK in $HDD; do
    if [ ! "$HDISK" = "" ]; then
	echo "Device_${DEVNO}=HDD ${HDISK}" >> $LOGFILE
	let DEVNO++
    fi
done

for CDDISK in $CDROM; do
    if [ ! "$CDDISK" = "" ]; then
	echo "Device_${DEVNO}=CdRom ${CDDISK}" >> $LOGFILE
	let DEVNO++
    fi
done
IFS=$OLDIFS

if [ -e /etc/slackware-version ]; then
    SOFTNO=0
    echo "[Linux_StartUp]" >> $LOGFILE
    for SOFT in `cd /etc/rc.d;ls rc.*`; do
	echo "Lin_Start_${SOFTNO}=${SOFT}" >> $LOGFILE
        let SOFTNO++
    done

    SOFTNO=0
    echo "[Linux_Soft]" >> $LOGFILE

    for SOFT in `ls /var/adm/packages`; do
	echo "Lin_Soft_${SOFTNO}=${SOFT}" >> $LOGFILE
        let SOFTNO++
    done

    for SOFT in `ls /opt`; do
        echo "Lin_Soft_${SOFTNO}=${SOFT}" >> $LOGFILE
        let SOFTNO++
    done
fi
